<template>
  <div class="main-page">
    <div class="main-page-header">
      <p class="title">急救药品耗材资源</p>
      <el-form
        :inline="true"
        :model="searchForm"
        ref="searchForm"
        size="small"
      >
        <el-form-item
          prop="hospitalCode"
          label="医院名称"
          v-if="checkPermission()"
        >
          <el-select
            v-model="searchForm.hospitalCode"
            placeholder="请选择医院"
            style="width: 100%"
            filterable
            remote
            :loading="selectLoading"
            :remote-method="remoteMethod"
            :clearable="true"
          >
            <el-option
              v-for="item in hospitalList"
              :label="item.hospitalName"
              :key="item.id"
              :value="item.hospitalCode"
            />
          </el-select>
        </el-form-item>
        <el-form-item
          prop="materialType"
          label="类型"
        >
          <el-radio-group v-model="searchForm.materialType">
            <el-radio label="">全部</el-radio>
            <el-radio label="1">药品</el-radio>
            <el-radio label="2">耗材</el-radio>
          </el-radio-group>
        </el-form-item>
        <div class="btns">
          <el-button
            type="primary"
            size="small"
            @click="search"
          >查询</el-button>
          <el-button
            size="small"
            @click="resetForm('searchForm')"
          >重置</el-button>
        </div>
      </el-form>
    </div>
    <div class="main-page-body">
      <div class="mainContent">
        <div class="bt">
          <el-button
            type="primary"
            size="small"
            @click="showSaveDialog()"
            v-if="!checkPermission()"
          >新增</el-button>
        </div>
        <table-mixin
          :pageSize="pageSize"
          :pageNum="pageNum"
          :total="total"
          :pagination="pagination"
          :handleSizeChange="handleSizeChange"
          :handleCurrentChange="handleCurrentChange"
        >
          <el-table
            v-loading="tableData.loading"
            :data="tableData.body"
            @sort-change="handleSortChange"
          >
            <div
              slot="empty"
              class="noData"
            ></div>
            <el-table-column
              label="序号"
              type="index"
              min-width="50"
            >
            </el-table-column>
            <el-table-column
              v-for="(item,index) in tableData.head"
              :prop="item.key"
              :label="item.name"
              align="left"
              :formatter="item.formatter"
              :sortable="item.sortable"
              :fixed="item.fixed"
              :key="index"
              :min-width="item.width"
              :show-overflow-tooltip="true"
            >
            </el-table-column>
            <el-table-column
              label="操作"
              align="left"
              width="auto"
              min-width="200px"
            >
              <template slot-scope="scope">
                <el-link
                  type="primary"
                  @click="showSaveDialog('detail', scope.row.id)"
                >查看详情</el-link>
                <el-link
                  type="primary"
                  v-if="!checkPermission()"
                  @click="showSaveDialog('update', scope.row.id)"
                >修改</el-link>
                <el-link
                  type="primary"
                  @click="delHandler(scope.row.id)"
                  v-if="!checkPermission() && scope.row.auditStatus != 4"
                >删除</el-link>
                <el-link
                  type="primary"
                  v-if="(scope.row.auditStatus === 1 || scope.row.auditStatus === 5) && checkPermission()"
                  @click="auditHandler(scope.row.id)"
                >审核</el-link>
              </template>
            </el-table-column>
          </el-table>
        </table-mixin>
        <SaveDialog
          ref="saveDialog"
          @subsucc="search"
        />
      </div>
    </div>
  </div>
</template>
<script>
import { tableDataMixin } from '../../common/js/mixin'
import { queryHospitalList } from '@/api/common'
import { queryEmergencyMedicalPageList, auditTeamEmergencyMedical, deleteEmergencyMedical } from '@/api/medical'
import SaveDialog from './components/saveDialog.vue'
export default {
  name: 'expertPage',
  mixins: [tableDataMixin],
  components: {
    SaveDialog
  },
  data() {
    return {
      searchForm: {
        hospitalCode: '',
        materialType: ''
      },
      hospitalList: [],
      selectLoading: false,
      tableData: {
        loading: false,
        head: [
          {
            name: '医院名称',
            key: 'hospitalName',
            sortable: false,
            width: '200',
            fixed: false
          },
          {
            name: '类型',
            key: 'materialTypeStr',
            sortable: false,
            width: '100',
            fixed: false
          },
          {
            name: '名称',
            key: 'materialName',
            sortable: false,
            width: '200',
            fixed: false
          },
          {
            name: '库存',
            key: 'storeCount',
            sortable: false,
            width: '150',
            fixed: false
          },
          {
            name: '所在位置',
            key: 'storePlaceStr',
            sortable: false,
            width: '300',
            fixed: false
          },
          {
            name: '审核状态',
            key: 'auditStatusStr',
            sortable: false,
            width: '100',
            fixed: false
          }
        ],
        body: [],
        option: [],
        condition: []
      }
    }
  },
  mounted() {
    //获取可选择的医院
    queryHospitalList().then(res => {
      this.hospitalList = res.respData
    })
    this.search()
  },
  methods: {
    getTableData() {
      this.tableData.loading = true
      const params = {
        ...this.searchForm,
        pageNo: this.pageNum,
        pageSize: this.pageSize
      }
      queryEmergencyMedicalPageList(params).then((res) => {
        if (res.msg == 201) {
          this.dealTableResponse(res)
        } else {
          this.$message.error(res.content)
        }
      })
    },
    remoteMethod(query) {
      this.selectLoading = true;
      queryHospitalList(query).then(res => {
        this.hospitalList = res.respData
        this.selectLoading = false;
      })
    },
    showSaveDialog(type = 'add', id = '') {
      this.$refs.saveDialog.init(type, id)
    },
    auditHandler(id) {
      this.$confirm('是否审批通过？', '提示', {
        confirmButtonText: '通过',
        cancelButtonText: '拒绝',
        distinguishCancelAndClose: true,
        type: 'warning'
      }).then(() => {
        this.auditData(id, 2)
      }).catch(action => {
        if (action === 'cancel') {
          this.auditData(id, 3)
        }
      })
    },
    auditData(id, auditStatus) {
      auditTeamEmergencyMedical({ id: id, auditStatus: auditStatus }).then(res => {
        if (res.msg === 201) {
          this.$message.success('操作成功！')
        } else {
          this.$message.error(res.content)
        }
        this.search()
      })
    },
    delHandler(id) {
      this.$confirm('此操作将永久删除该数据, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        deleteEmergencyMedical({ id: id }).then(res => {
          if (res.msg === 201) {
            this.$message.success('进入删除审核中！')
          } else {
            this.$message.error(res.content)
          }
          this.search()
        })
      })
    }
  }
}
</script>
<style lang="scss" scoped>
.mainContent {
  padding: 20px;
  .bt {
    text-align: right;
    margin-bottom: 16px;
  }
}
</style>
